/* Copyright(C) (2012) (ID - IMAG) <Jean-Marc.Vincent@imag.fr> */

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



/*! \file generateur.c
 * \brief  experimentation tri par tas
 * \author Jean-Marc.Vincent@imag.fr 
 *
 * \version 1.0
 * \date 2012
 */

/*
 *------------------------------------------------------------------
 * Fichier      : generateur.c
 * Langage      : C 
 * Auteur       : Jean-Marc Vincent
 * Creation     : 23/01/2012
 *--------------------------------------------------------------------
 * Description  :
 *          generation de permutations aleatoires uniformes dans un tableau
 *--------------------------------------------------------------------
 */

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

int init_generateur() /* Initialisation du generateur avec
			  le numero du processus   */
{
  int i;
  i=getpid();
  srandom(i);
  return i;
}

double u01() /* loi uniforme sur 0,1 */
{
  return( (double) random() * .4656612875e-9); 
  /* optimisation pour eviter l'operateur de division qui est couteux */
}
  


void genere_tableau(int *Tableau,int n) /* generation tableau */
{
  int i,j; /* indice de boucle pour remplir le tableau */
  int x;   /*element courant */
  for (i=0; i<n;i++) for (j=0; j<n; j++) Tableau[i]=i;
  for (i=n-1; i>0; i--) 
	{
	j=floor(u01()*(i+1));
	x=Tableau[i]; Tableau[i]=Tableau[j]; Tableau[j]=x;
	}
}

void imprime_tableau(int *Tableau,int n) /* imprime tableau */
{
  int i; /* indice de boucle pour parcourir le tableau */
  printf("[");
  for (i=0; i<n;i++) printf("%d,",Tableau[i]);
  printf("]");
}


