/* Copyright(C) (2012) (ID - IMAG) <Jean-Marc.Vincent@imag.fr> */

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/*
 *------------------------------------------------------------------
 * Fichier      : statistique.c
 * Langage      : C 
 * Auteur       : Jean-Marc Vincent
 * Creation     : 23/01/2012
 *--------------------------------------------------------------------
 * Description  :
 *          fonctions statistiques
 *--------------------------------------------------------------------
 */
#include <stdlib.h>						 
#include <stdio.h>


void tri_quick(int *T,int p, int r)  
     /* trie le tableau T de l'element p a l'element r */
{
  int i;        /* position courante du pivot */
  int j;           /* indice place disponible pour mettre un élément plus grand que le pivot */
  int x;           /* valeur temporaire pour faire l'echange  */
  if (r-p >0)
  {
  i=p; j=r;
  while (j-i>0)
	{
	if (T[i] >= T[i+1]) 
		{
			x=T[i]; T[i]=T[i+1]; T[i+1]=x;
			i++;
		}
	else
		{
			x=T[j]; T[j]=T[i+1]; T[i+1]=x;
			j--;
		}
	}
  
   tri_quick(T,p,i-1); 
   /* on trie les elements du tableau a gauche du pivot */
   
  tri_quick(T,i+1,r); 
	/* on trie les elements a droite du pivot  */
  }
}

void statistique(double *indice_stat,int *echantillon,int taille_echantillon)
{
  double somme,somme2;
  int i;
 
  tri_quick(echantillon,0,taille_echantillon-1);
  indice_stat[0]=echantillon[0];
  indice_stat[1]=echantillon[taille_echantillon/4];
  indice_stat[2]=echantillon[taille_echantillon/2];
  indice_stat[3]=echantillon[3*taille_echantillon/4];
  indice_stat[4]=echantillon[taille_echantillon-1];
  somme=0;
  somme2=0;
  for (i=0; i<taille_echantillon; i++){
    somme+=echantillon[i];
    somme2+=echantillon[i]*echantillon[i];
  }
  indice_stat[5]=somme/(double) taille_echantillon;
  indice_stat[6]=(somme2 - somme*somme/((double) taille_echantillon))/((double) taille_echantillon-1);
}

void histogramme(double *hist,int taille_histogramme,double *indices_stat,int* echantillon,int taille_echantillon)
{
  int i;
  double pas;
  pas = (indices_stat[4]-indices_stat[0])/taille_histogramme;
  for (i=0; i<taille_histogramme; i++)hist[i]=0;
  for (i=0; i<taille_echantillon; i++)hist[(int)((echantillon[i]-indices_stat[0])/pas)]++;
  for (i=0; i<taille_histogramme; i++)hist[i]=(double) hist[i]/(pas*taille_echantillon);
}

void imprime_statistique(double *indices_stat)
{
  printf("# min %7.f\n",indices_stat[0]);
  printf("# Q1  %7.f\n",indices_stat[1]);
  printf("# med %7.f\n",indices_stat[2]);
  printf("# Q3  %7.f\n",indices_stat[3]);
  printf("# max %7.f\n",indices_stat[4]);
  printf("# avg %10.2f\n",indices_stat[5]);
  printf("# var %10.2f\n",indices_stat[6]);  
}

void imprime_histogramme(double *hist,double *indices_stat,int taille_histogramme)
{
  int i;
  double pas;
  pas = (indices_stat[4]-indices_stat[0])/taille_histogramme;
  for (i=0; i<taille_histogramme; i++) 
    printf("%10.2f %f \n",indices_stat[0]+i*pas,hist[i]);
}
