/* Copyright(C) (2012) (ID - IMAG) <Jean-Marc.Vincent@imag.fr> */

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/*
 *------------------------------------------------------------------
 * Fichier      : statistique.h
 * Langage      : C 
 * Auteur       : Jean-Marc Vincent
 * Creation     : 23/01/2012
 *--------------------------------------------------------------------
 * Description  :
 *          prototypage des fonctions statistiques
 *--------------------------------------------------------------------
 */

/*
   statistique
   description : initialise le generateur construit les resumes statistiques
   et les insere dans le tableau d'indices statistiques calcule dans l'ordre 
   min Q1 Q2 Q3 max moyenne sigma
   parametres : tableau avec les 7 valeurs, tableau contenant les echantillons,
   et la taille de ce tableau
   valeur de retour : aucune
   effets de bord : aucun
*/
void statistique(double *indice_stat,int *echantillon,int taille_echantillon);


/*
   histogramme
   description : calcule l'histogramme par classes regulieres entre la valeur 
   min et la valeur max
   parametres : tableau de resultats,nombre de classes de l'histogramme, 
   tableau avec les 7 valeurs, tableau contenant les echantillons, 
   taille du tableau
   et la taille de ce tableau
   valeur de retour : aucune
   effets de bord : calcule la synthese dans le tableau hist
*/
void histogramme(double *hist,int taille_histogramme,double *indices_stat,int* echantillon,int taille_echantillon);


/*
   imprime_statistique
   description : imprime les valeurs des statistiques
   parametres : tableau avec les 7 valeurs
   valeur de retour : aucune
   effets de bord : imprime les statistiques
*/  
void imprime_statistique(double *indices_stat);

/*
   imprime_histogramme
   description : imprime les valeurs de l'histogramme sur 2 colonnes x,p(x)
   parametres : tableau histogramme, tableau avec les 7 valeurs, 
   valeur de retour : aucune
   effets de bord : imprime l'histogramme
*/  
void imprime_histogramme(double *hist,double *indices_stat,int taille_histogramme);

